#include<stdio.h>
#include<stdlib.h>

//pomocna funkcija za apsolutnu vrijednost
double aps(double broj){
    return (broj >= 0) ? broj : -broj;
}

//pomocna funkcija racuna prosjek i-tog ucenika
//(preskoci sifru na pocetku, racuna prosjek sve dok ne naleti na -1)
double prosjek(int niz[]){
    int zbroj_ocjena = 0, br_ocjena = 0;
    int i;
    for(i = 1; niz[i] != -1; ++i){
        zbroj_ocjena += niz[i];
        br_ocjena++;
    }
    return (1.0*zbroj_ocjena)/br_ocjena;
}

//funkcija koja treba u dijelu za dodatne bodove
//zbog poziva funkcije qsort iz stdlib.h
int komparator (const void * a, const void * b) {
    int *prvi = *(int**) a;
    int *drugi = *(int**) b;

    double prosjek1 = prosjek(prvi), prosjek2 = prosjek(drugi);

    if(prosjek1 >= prosjek2)
        return 1;
    else if(prosjek1 == prosjek2)
        return 0;
    else
        return -1;
}


int main(void){
    //ucitamo broj ucenika
    int n;
    scanf("%d", &n);

    //matrica sa siframa i ocjenama
    int** X;
    X = (int**)malloc(n * sizeof(int*));

    //unos podataka za svakog od n ucenika u niz X[i]
    int i;
    for(i = 0; i < n; ++i){
        //prvo sifra
        int sifra;
        scanf("%d", &sifra);
        X[i] = (int*)malloc(1*sizeof(int));
        X[i][0] = sifra;

        //unos ocjena - prekida se nakon sto je ucitano i spremljeno -1
        int br_ocjena = 0;
        while(1){
            int ocjena;
            scanf("%d", &ocjena);
            br_ocjena++;
            //spremi ocjenu -> 1. ocjena u X[i][1], 2. u X[i][2], itd.
            X[i] = (int*)realloc(X[i],(br_ocjena+1)*sizeof(int));
            X[i][br_ocjena] = ocjena;
            if(ocjena == -1)
                break;
        }
    }

    //odredimo najveci prosjek:
    double max = prosjek(X[0]);
    for(i = 1; i < n; ++i){ //nije greska ako i ide od 0 :)
        if(prosjek(X[i]) > max)
            max = prosjek(X[i]);
    }

    printf("ucenici s najvecim prosjekom: ");
    for(i = 0; i < n; ++i){
        //if(prosjek(X[i]) == max) -> usporedba dva double broja cesto ne radi dobro
        if(aps(prosjek(X[i]) - max) < 0.0001)
            printf("%d (prosjek: %g)\n", X[i][0], prosjek(X[i]));
    }


    /*
    SORTIRANJE  - sortiramo quick sort algoritmom
        - to nosi 15 bodova
        - ukoliko je (ispravno) koristen algoritam cija je prosjecna
          vremenska slozenost gora od n log n, to nosi najvise 10 bodova
        - kako je u ovome zadatku dozvoljeno koristiti stdlib.h,
          umjesto vlastite implementacije, mozemo koristiti funkciju qsort
          iz biblioteke stdlib ciji je prototip:
    void qsort(void *base, size_t nitems, size_t size,
               int (*compar)(const void *, const void*))
        - za ovo je potrebna funkcija komparator (ili compar) koja je
          ovdje implementirana neposredno prije main funkcije
    */
    qsort(X, n, sizeof(int*), komparator);


    //ovdje je ispis redom po siframa i prosjecima samo za
    //testiranje sort-a i ne ocekuje se u rjesenjima
    printf("Ispis ucenika po prosjecima:\n");
    for(i = 0; i < n; ++i){
        printf("%10d (prosjek: %4.2lf)\n", X[i][0], prosjek(X[i]));
    }

    //dealokacija memorije
    //paziti da dealokacija X[i]-jeva ide prije dealokacije X!
    for(i = 0; i < n; ++i)
        free(X[i]);

    free(X);

    return 0;
}
