#include <stdio.h>
#include <stdlib.h>

int gube_pravo(char **niz, int n, char **rezultat) {
	int i,j,razmaka,l=0,jmbagova=0;

	/* Budući da zadatak ne pretpostavlja da se izvan ove *
	 * funkcije *rezultat postavi na NULL, vrijednost mu  *
	 * postavljamo ovdje. Tada će nam biti jednostavnije  *
	 * pozvati realloc (prvi poziv, koji će tad zapravo   *
	 * biti običan malloc, time pišemo isto kao ostale).  */                     

	*rezultat=NULL;

	for(i=0; i<n; i++) {

		/* Informacije po kojima filtriramo JMBAG-ove se nalaze *
		 * neposredno iza treceg razmaka.                       */

		j=0;
		for(razmaka=0; razmaka<3; ) 
			if (niz[i][j++]==' ')
				++razmaka;

		/* Naravno, iduci se dio moze napisati na ogroman broj      *
		 * razlicitih, a podjednako dobrih nacina. Kod provjere     *
		 * da je godina upisa jednaka 2019 pazimo na broj znamenki. */

		if(niz[i][j]!='2'  || niz[i][j+1]!='0' ||
		   niz[i][j+2]!='1'|| niz[i][j+3]!='9' || niz[i][j+4]!=' ')
			continue;

		/* Zatim jos provjerimo je li broj dovoljno malen (ili    *
		 * jednoznamenkast, ili je prva znamenka strogo manja     *
		 * od 3, ili je prva znamenka jednaka 3 te druga strogo   *
		 * manja od 5. Pazite, niz[i][j+5] ne moze biti jednak 3, *
		 * ali moze biti jednak '0'+3.                            */

		if(!(niz[i][j+6]=='\0' ||
		     niz[i][j+5]<'0'+3 ||
		     (niz[i][j+5]=='0'+3 && niz[i][j+6]<'0'+5)))
			continue;

		/* Ako smo do ovdje došli, JMBAG spremamo, pa dodajemo *
		 * jedan buducoj povratnoj vrijednosti. Ako smo vec    *
		 * spremali JMBAG-ove, jos dodamo razmak u rezultat.   */

		++jmbagova;
		
		if (jmbagova>1) {
			*rezultat=realloc(*rezultat, l+1);
			(*rezultat)[l++]=' ';
		}

		/* Postupno alociramo tocno onoliko mjesta koliko nam *
		 * je potrebno za dodati JMBAG u rezultat. Pritom     *
		 * posebno pazimo na dealokaciju memorije koja nam    *
		 * vise nije potrebna.                                */ 

		for(j=0; niz[i][j]!=' '; ) {
			*rezultat=realloc(*rezultat, l+1);
			(*rezultat)[l++]=niz[i][j++];
		}
	}	
	*rezultat=realloc(*rezultat, l+1);
	(*rezultat)[l]='\0';
	return jmbagova;
}

int main(void) {
	char *niz[]={"0123456789 Ana Anic 2019 34",
		     "1234567890 Pero Perovic 2020 42",
		     "2345678901 Ivan Ivkovic 2021 30",
		     "3456789012 Marija Maric 2019 35",
		     "4567890123 Una Unic 2019 30"};
	char *jmbagovi;
	printf("Broj studenata: %d, ",gube_pravo(niz,5,&jmbagovi));
	printf("JMBAG-ovi: %s\n",jmbagovi);
	return 0;
}

